#include <Profiles/BicycleSpeed/DataPages/Base/ANTPLUS_BicycleSpeedBaseMainDataPage.h>
#include <Profiles/BicycleSpeed/ANTPLUS_BicycleSpeedPrivateDefines.h>

BicycleSpeedBaseMainDataPage::BicycleSpeedBaseMainDataPage(AntRxDataResponse& dp) : BaseDataPage<BroadcastData>(dp) {

}

uint8_t BicycleSpeedBaseMainDataPage::getDataPageNumber() {
    return getData(ANTPLUS_BICYCLESPEED_DATAPAGEBASE_DATAPAGE_BYTE) & ANTPLUS_BICYCLESPEED_DATAPAGEBASE_DATAPAGE_MASK;
}

uint8_t BicycleSpeedBaseMainDataPage::getPageChangeToggle() {
    return (getData(ANTPLUS_BICYCLESPEED_DATAPAGEBASE_TOGGLE_BYTE) & ANTPLUS_BICYCLESPEED_DATAPAGEBASE_TOGGLE_MASK) >> ANTPLUS_BICYCLESPEED_DATAPAGEBASE_TOGGLE_SHIFT;
}

uint16_t BicycleSpeedBaseMainDataPage::getBikeSpeedEventTime() {
    return (getData(ANTPLUS_BICYCLESPEED_DATAPAGEBASE_BIKESPEEDEVENTTIMEMSB_BYTE) << ANTPLUS_BICYCLESPEED_DATAPAGEBASE_BIKESPEEDEVENTTIMEMSB_SHIFT) | getData(ANTPLUS_BICYCLESPEED_DATAPAGEBASE_BIKESPEEDEVENTTIMELSB_BYTE);
}

uint16_t BicycleSpeedBaseMainDataPage::getCumulativeSpeedRevolutionCount() {
    return (getData(ANTPLUS_BICYCLESPEED_DATAPAGEBASE_CUMULATIVESPEEDREVOLUTIONCOUNTMSB_BYTE) << ANTPLUS_BICYCLESPEED_DATAPAGEBASE_CUMULATIVESPEEDREVOLUTIONCOUNTMSB_SHIFT) | getData(ANTPLUS_BICYCLESPEED_DATAPAGEBASE_CUMULATIVESPEEDREVOLUTIONCOUNTLSB_BYTE);
}
